extern crate unic;

fn main() {
    let mut text: String = String::new();
    loop {
        let read_line_result = std::io::stdin().read_line(&mut text);
        match read_line_result {
            Ok(x) => {
                if x >= 1 {

                let bidi_info = unic::bidi::BidiInfo::new(&text.as_str(), None);

                for paragraph in bidi_info.paragraphs.iter() {
                    print!(
                        "{}",
                        bidi_info.reorder_line(&paragraph, paragraph.range.clone())
                    );
                }
                } else {
                    return;
                }

                text = "".to_string();
            }
            Err(_) => { return; }
        }
    }
}
